<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class CriticalCommand
 * @package FiloBlu\Flow\Console\Command
 */
class CriticalCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $_state;

    /**
     * @var \FiloBlu\Flow\Cron\FetchFactory
     */
    protected $_cronFactory;

    /**
     * CriticalCommand constructor.
     * @param \Magento\Framework\App\State $state
     * @param \FiloBlu\Flow\Cron\FetchFactory $cronFactory
     */
    public function __construct(\Magento\Framework\App\State $state, \FiloBlu\Flow\Cron\FetchFactory $cronFactory)
    {
        $this->_state = $state;
        $this->_cronFactory = $cronFactory;
        parent::__construct();
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:critical')
            ->setDescription('Process critical flows executing fetch receive parse and process in one shot');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|null|void
     * @throws \Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->_state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $output->writeln("Areacode was already set, skipping!");
        }

        $cronModel = $this->_cronFactory->create();
        $cronModel->processCritical();

        $output->writeln('<info>Processed criticals !</info>');
    }

}